package 
{
	import com.bit101.components.CheckBox;
	import com.bit101.components.Label;
	import com.bit101.components.PushButton;
	import com.bit101.components.Window;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import ui.cursors.Cursor;
	import ui.cursors.CursorManager;
	import ui.cursors.Switcher;
	
	public class CursorManagerExamples extends Sprite 
	{
		
		public function CursorManagerExamples()
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			// Инициализация курсоров
			var defaultCursor:Cursor = new Cursor(
				new Label(null, 0, 0, "Default cursor"), 10, 14, true);
			var cursor0:Cursor = new Cursor(
				new Label(null, 0, 0, "Cursor 0"), 10, 14, true);
			var cursor1:Cursor = new Cursor(
				new Label(null, 0, 0, "Cursor 1"), 10, 14, true);
			var waitCursor:Cursor = new Cursor(
				new Label(null, 0, 0, "Please wait..."), 0, 0, true, true);
			
			// Установка дефолтного курсора
			CursorManager.init(stage, stage);
			CursorManager.defaultCursor = defaultCursor;
			
			// Добавление курсора на кнопку
			var button0:PushButton = new PushButton(this, 0, 0, "Button 0");
			CursorManager.newHover().setTarget(button0).setCursor(cursor0);
			
			// Кнопка с блокировкой курсоров
			var buttonWithCursorLock:PushButton = new PushButton(
				this, 0, 30, "Button with cursor lock");
			buttonWithCursorLock.width = 120;
			CursorManager.newHover()
				.setTarget(buttonWithCursorLock).setCursor(null);
			
			// Кнопка без установки курсора
			new PushButton(this, 0, 60, "Button without cursor").width = 120;
			
			// Кнопки в окне
			var window:Window = new Window(
				this, 0, 200, "Window without cursor");
			window.width = 120;
			CursorManager.newHover().setTarget(window).setCursor(null);
			var button1:PushButton = new PushButton(
				window.content, 10, 10, "Button 1");
			CursorManager.newHover().setTarget(button1).setCursor(cursor1);
			var windowButtonWithoutCursor:PushButton = new PushButton(
				window.content, 0, 50, "Button without cursor");
			windowButtonWithoutCursor.width = 120;
			window.content.addChild(windowButtonWithoutCursor);
			
			// Чек-бокс включения курсора ожидания, затмевающего остальные
			_waitSwitcher = CursorManager.newSwitcher(1).setCursor(waitCursor);
			_waitCheckBox = new CheckBox(this, 130, 0, "Enable wait");
			_waitCheckBox.addEventListener(MouseEvent.CLICK, onWaitClick);
			
			// Изменение курсора кнопки
			var randomButton:PushButton = new PushButton(
				this, 130, 30, "Click for random cursor", onSetRandomClick);
			randomButton.width = 120;
			randomButton.addEventListener(MouseEvent.CLICK, onSetRandomClick);
			_randomSwitcher = CursorManager.newHover().setTarget(randomButton);
		}
		
		private var _waitCheckBox:CheckBox;
		private var _waitSwitcher:Switcher;
		
		private function onWaitClick(event:MouseEvent):void
		{
			_waitSwitcher.enabled = _waitCheckBox.selected;
		}
		
		private var _randomSwitcher:Switcher;
		
		private function onSetRandomClick(event:MouseEvent):void
		{
			_randomSwitcher.cursor = new Cursor(
				new Label(null, 0, 0, "Random cursor: " + Math.random()),
				10, 14, true);
		}
	}
	
}