package ui.cursors
{
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.InteractiveObject;
	
	public class Cursor
	{
		/**
		 * @param	view - курсор на базе DisplayObject, который будет смещён
		 * относительно положения мыши на offsetX и offsetY
		 * @param	offsetX
		 * @param	offsetY
		 * @param	updateOnMove - нужно ли вызывать event.updateAfterEvent()
		 * при перемещении мыши
		 * @param	hideSystem - прятать ли системный курсор
		 * @param	systemCursor - одно из значений flash.ui.MouseCursor
		 */
		public function Cursor(
			view:DisplayObject = null, offsetX:int = 0, offsetY:int = 0,
			updateOnMove:Boolean = false, hideSystem:Boolean = false,
			systemCursor:String = null) 
		{
			_view = view;
			if (_view is InteractiveObject)
			{
				(_view as InteractiveObject).mouseEnabled = false;
			}
			if (_view is DisplayObjectContainer)
			{
				(_view as DisplayObjectContainer).mouseChildren = false;
			}
			_offsetX = offsetX;
			_offsetY = offsetY;
			_updateOnMove = updateOnMove;
			_hideSystem = hideSystem;
			_systemCursor = systemCursor;
		}
		
		private var _view:DisplayObject;
		public function get view():DisplayObject
		{
			return _view;
		}
		
		private var _hideSystem:Boolean;
		public function get hideSystem():Boolean
		{
			return _hideSystem;
		}
		
		private var _systemCursor:String;
		public function get systemCursor():String
		{
			return _systemCursor;
		}
		
		private var _updateOnMove:Boolean;
		public function get updateOnMove():Boolean
		{
			return _updateOnMove;
		}
		
		private var _offsetX:int;
		public function get offsetX():int
		{
			return _offsetX;
		}
		
		private var _offsetY:int;
		public function get offsetY():int
		{
			return _offsetY;
		}
	}
}